#ifndef _BTREE_H_
#define _BTREE_H_

#include "mess.h"

typedef enum {LEFT, RIGHT}
NodeType;

typedef struct MessStack
{
    Message_Struct       Mess;
    struct MessStack     *Succ;
}
MessStack;


typedef struct BTree_Struct
{
    struct BTree_Struct     *Left,
                     *Right,
                     *Up;
    MessStack        *MessData;
    int16            Priority,
                     NodeStatus;
    NodeType         Type;
}
BTree_Struct;



void AddMess(Message_Struct* Mess);
void ClearMessTree(void);



void RotateRight(BTree_Struct* A);
void RotateLeft(BTree_Struct* A);
void LiftLeft(BTree_Struct* Node);
void LiftRight(BTree_Struct* Node);
void PushMess(Message_Struct* Mess, BTree_Struct* Node);
void ClearNode(BTree_Struct* Node);
void CheckTree(BTree_Struct* Node);
#endif
